projet-final-web-app/Models/DefaultDbContext.cs
using Microsoft.EntityFrameworkCore;
using System;
using twitch.api;
using static Microsoft.EntityFrameworkCore.DbLoggerCategory.Database;


namespace projet_final_web_app.Models
{
    public class DefaultDbContext : DbContext
    {
        public DbSet<Streamer> Streamers { get; set; }
        public DbSet<Follower> Followers { get; set; }
        public DbSet<twitch.api.Stream> Streams { get; set; }
        public DbSet<twitch.api.Session> Sessions { get; set; }

        public DefaultDbContext(DbContextOptions options) : base(options)
        {
        }

        protected DefaultDbContext()
        {
        }
    }
}

projet-final-web-app/Models/ErrorViewModel.cs
namespace projet_final_web_app.Models
{
    public class ErrorViewModel
    {
        public string? RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

projet-final-web-app/Models/FollowersActivityModel.cs
using Microsoft.AspNetCore.Mvc;
using twitch.api;

namespace projet_final_web_app.Models
{
    public class FollowersActivityModel
    {
        public List<Follower> Followers { get; set; }

        [BindProperty]
        public OptionType Option { get; set; }
    }
}

projet-final-web-app/Models/OptionType.cs
namespace projet_final_web_app.Models
{
    public enum OptionType
    {
        All,
        Active
    }
}

projet-final-web-app/Controllers/FollowerController.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore.Diagnostics;
using Microsoft.EntityFrameworkCore.Query.SqlExpressions;
using projet_final_web_app.Models;


namespace projet_final_web_app.Controllers
{
    /// <summary>
    /// Classe FollowerController associé aux interactions avec les followers du contexte
    /// </summary>
    public class FollowerController : Controller
    {
        private readonly DefaultDbContext context;
        public FollowerController(DefaultDbContext context)
        {
            this.context = context;
        }
        /// <summary>
        /// Action de listage des follower du contexte
        /// </summary>
        /// <returns>Retourne vers la vue Liste</returns>
        public IActionResult List()
        {
            var query = from follower in this.context.Followers
                        select follower;
            return View(query.ToList());
        }

        /// <summary>
        /// Action de listage des follower connectés
        /// </summary>
        /// <returns>Retourne vers la vue list</returns>
        public IActionResult ConnectionList()
        {
            var query = from follower in this.context.Followers
                        where follower.IsConnected == true
                        select follower;
            return View("List", query.ToList());
        }

        /// <summary>
        /// Action de listage des followers les plus actifs ou bien de l 'ensemble des followers selon le parametre option
        /// </summary>
        /// <param name="model"></param>
        /// <returns>Retourne vers la vue Activity</returns>
        public IActionResult FollowersActivity(FollowersActivityModel model)
        {
            if (model.Option == OptionType.All)
            {
                var followersQuery = from follower in this.context.Followers
                                     select follower;
                model.Followers = followersQuery.ToList();
            }

            if (model.Option == OptionType.Active)
            {
                int nbStream = this.context.Streams.Count();

                var filteredSessions = from session in this.context.Sessions
                                      where session.StreamId != null
                                      select session;

                var activeFollowersIdQuery = from session in filteredSessions
                                             group session by session.FollowerId into followerGroup
                                             where followerGroup.Count() / nbStream > 0.7
                                             select followerGroup.Key;

                var activeFollowersQuery = from follower in this.context.Followers
                                           where activeFollowersIdQuery.Contains(follower.Id)
                                           select follower;

                model.Followers = activeFollowersQuery.ToList();
            }

            return View("Activity", model);
        }
    }
}

projet-final-web-app/Controllers/HomeController.cs
using Microsoft.AspNetCore.Mvc;
using projet_final_web_app.Models;
using System.Diagnostics;

namespace projet_final_web_app.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

projet-final-web-app/Views/Follower/Activity.cshtml
@using twitch.api
@model FollowersActivityModel
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
}

<h1>Filtrer les followers</h1>

<form asp-action="FollowersActivity" asp-controller="Follower" id="active-followers-form" method="post">
    <select name="Option" asp-items="Html.GetEnumSelectList<OptionType>()" asp-for=@Model.Option></select>
</form>

<table class="table">
    <tr>
        <th>Pseudo</th>
        <th>Profile Picture</th>
    </tr>
    <tbody>
        @foreach (var follower in Model.Followers)
        {
            <tr>
                <td>@follower.Pseudo</td>
                <td><img src="@follower.ProfilePicture") /></td>
            </tr>    
        }
    </tbody>
</table>

<script>
    const form = document.querySelector('#active-followers-form')
    const select = form.querySelector('select')
    select.addEventListener('change', (el, evt) => form.submit())
</script>

projet-final-web-app/Views/Follower/Index.cshtml
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
}

<input type=text list=browsers >
<datalist id=browsers >
   <option> Google </option>
   <option> IE9 </option>
</datalist>

projet-final-web-app/Views/Follower/List.cshtml
@using twitch.api
@model List<Follower>
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
}

<h1>Followers</h1>

<table class="table">
    <tr>
        <th>Pseudo</th>
        <th>Profile Picture</th>
    </tr>
    <tbody>
        @foreach (var follower in Model)
        {
                <tr>
                    <td>@follower.Pseudo</td>
                    <td><img src="@follower.ProfilePicture" /></td>
                </tr>    
        }
    </tbody>
</table>

projet-final-web-app/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
</div>

projet-final-web-app/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - projet_final_web_app</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/projet_final_web_app.styles.css" asp-append-version="true" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container-fluid">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">projet_final_web_app</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Follower" asp-action="List">Followers</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Follower" asp-action="ConnectionList">Followers connectés</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Follower" asp-action="FollowersActivity">Followers actifs</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2023 - projet_final_web_app - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>